from django.shortcuts import render
from django.http import HttpResponse
from . models import Questions
from . models import quiz
from django.core.paginator import Paginator
from .forms import UploadFileForm
from django.http import HttpResponseRedirect
from .models import submission
from .models import cribs
from . newQuiz import readCSV
from .models import quiz
from django.db.models import Max
import csv
#for login
from django.contrib.auth.models import User
from django.contrib.auth.forms import UserCreationForm
from django.contrib.auth import login
from django.contrib.auth.decorators import login_required
from django.db.models import Count

lst = []

answers = []
anslist = []
marksList=[]
negative=[]


def index(request):
    obj = Questions.objects.get_queryset().order_by('questionId')
    count = Questions.objects.all().count()
    print(obj)
    """ paginator = Paginator(obj,1)
    try:
       page = int(request.GET.get('page','1'))  
    except:
        page =1
    try:
        questions = paginator.page(page)
    except Exception as e:

        questions=paginator.page(paginator.num_pages) """
    return render(request,'index.html',{'questions':obj,'count':count})
    #quiz started #quiz  completed. 

@login_required
def result(request):
    if request.user.is_authenticated and request.method =="POST":
        quizId=int(request.POST['quizId'])
        quizInstance = quiz.objects.get(pk=quizId)
        prev_subm = submission.objects.all().filter(quizId=quizInstance, studentId=request.user)
        if len(prev_subm)==0:
            for questionno in request.POST:
                if questionno.startswith('question_'):
                    questionId = int(questionno[9:])
                    questionInstance = Questions.objects.get(pk=questionId)
                    t=submission(questionId=questionInstance, option=request.POST[questionno], studentId=request.user, quizId=quizInstance)
                    t.save()
            return HttpResponse("Successfully Submitted")
        else:
            return HttpResponse("You have already submitted this quiz")

    """ answer=list() #contains user responses
    ans=list()
    for req in request.POST:
        ans.append(req) """
    """ i=len(request.POST)
        j=2
        score=0
        while j<=i-2:
            q=Questions.objects.all().filter(quizId=quizId,questionId=request.POST[ans[j-1]]).values()#fetch the given quiz answers marks and negative marking
            print(request.POST[ans[j-1]])
            if(len(q)>=1):
                if(request.POST[ans[j]]==q[0]['answer']):
                    score+=q[0]['marks']
                elif(request.POST[ans[j]]!='NA'):
                    score-=q[0]['negative']
                print("Score: " +str(score))
                answer.append(request.POST[ans[j]])
                t=submission(questionId=Questions.objects.get(pk=int(request.POST[ans[j]])),option=request.POST[request.POST[ans[j]]],studentId=6969,quizId=quiz.objects.get(pk=int(quizId)))#studentid hardcoded
                t.save() 
            else:
                print(str(request.POST[ans[j-1]]))
            j+=2 
             """
                

    
    
def save_ans(request):
    ans = request.GET['ans']
    quizId=request.GET['quizId']
    questionId=request.GET['questionId']
    studentId=1# initialize here student id
    t=submission(questionId=questionId,option=ans,quizId=quizId,studentId=studentId)
    t.save()
    lst.append(ans)
    return HttpResponse('')

def save_cribs(request):
    crib=request.GET['cribs']
    studentId=1#set student id here 
    quizId=request.GET['quizId']
    questionId=request.GET['questionId']
    t=cribs(cribs=cribs,studentId=studentId,questionId=questionId,quizId=quizId)
    t.save()
    return HttpResponse('Suuuuuccess')  
    
def upload(request):
    return render(request,'upload.html')

@login_required
def student(request):
    
    return render(request,'student.html')

def upload_file(request):
    uploaded=False
    temp1='test'
    q= quiz(length=90,quizCode='abcd',quizDone=False)
    q.save()
    form = UploadFileForm(request.POST, request.FILES)
    if request.method == 'POST' and form.is_valid():
        handle_uploaded_file(request.FILES['file'],q)
        uploaded=True
        return HttpResponse('success')
        
    else :
        return render(request,'upload.html',{temp1:'invalid File'})
    
    

def handle_uploaded_file(f,q1):
    with open('name.csv', 'wb+') as destination:
        for chunk in f.chunks():
            destination.write(chunk)
    destination=open("name.csv","r") 
    rows=readCSV(destination)
    for row in rows:
        
        q=Questions(question=row[0],option1=row[1],option2=row[2],option3=row[3],option4=row[4],answer=row[5],type=row[6],marks=int(row[7]),negative=float(row[8]),explainations=row[9],quizCode=row[10],quizId=q1)#hardcoded quizid
        q.save()




#login functionality
def sign_up(request):
    context = {}
    form = UserCreationForm(request.POST or None)
    if request.method == "POST":
        if form.is_valid():
            user = form.save()
            login(request,user)
            return render(request,'student.html')
    context['form']=form
    return render(request,'registration/signup.html',context)



@login_required
def submissions(request):
    #prev_subm = submission.objects.all().filter(studentId=request.user)
    prev_subm = submission.objects.all().filter(studentId=request.user).values('quizId').annotate(dcount=Count('quizId'))
    return render(request,'submissions.html', { 'submissions' : prev_subm })


@login_required
def view_sub(request):
    if request.method == "GET":
        quizId = int(request.GET.get('q'))
        quizInstance = quiz.objects.get(pk=quizId)
        subs = submission.objects.filter(quizId=quizInstance, studentId=request.user).select_related().all()
        for sub in subs:
            print(sub.questionId.question)
        return render(request,'view_submissions.html', { 'submissions' : subs })

